#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#define SIZEofBUFF 20

int main (int argc, char** argv) {
   // mixed I/O is used here.. 
   // first file gets read through high level I/O lib calls
   FILE *fpa=NULL;
   // file to be created is handle through a file descriptor 
   // and in order to write into it, we use respective lib calls.
   int fd;

   int  counter=1;
   float thevalue=0.00;
   char record[20];
   int numOfrecords, i;
	
   // inline param number check
   if (argc!=3) {
      	printf("Correct syntax is: %s InputCSVfile OutFile.bin\n", argv[0]);
      	return(1);
   	}

   // stream-based input
   fpa=fopen(argv[1],"r");

   // low-level output file - characters
   fd=open(argv[2], O_RDWR|O_CREAT , 0755);

   while ( fscanf(fpa,"%d %s %f",&counter, record, &thevalue)!=EOF ) {
           printf("%d %s %f\n",counter, record, thevalue);
	   // above only high level calls are used to read in 
	   // content from fpa file pointer
	   //
	   // just low-level call write is used to write 
           // the 3 elements making up each record
           write(fd, &counter, sizeof(int));
           write(fd, record, sizeof(record));
           write(fd, &thevalue, sizeof(float));
   }

   fclose(fpa);
   close(fd);
}
