#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>

// look up DIRECTLY a record from a binary file whose structure is KNOWN

int main (int argc, char** argv) {
   // high-level I/O file pointer
   FILE *fpa;
   int numOfrecords, i;
   int locationOfSoughtRec=0;
   long lSize;
   char buffer[20];
   int  myid;
   float strsize;

   if (argc!=3) {
      	printf("Correct syntax is: %s BinaryFile Position\n", argv[0]);
      	return(1);
   	}
   // designate the recond to be directly retrived
   locationOfSoughtRec=atoi(argv[2]);

   fpa = fopen (argv[1],"rb");

   if (fpa== NULL) {
      	printf("Cannot access binary file %s\n",argv[1]);
      	return 1;
   	}
	
   // seek/go all the way to the end of the file
   fseek(fpa, 0, SEEK_END);
   // in current position find what is the # of the byte u r 
   // looking at - this is the size in terms of bytes
   lSize = ftell(fpa);
   // go back to the beginning of the file
   rewind(fpa);
   printf("Size of Size found to be %ld Bytes\n",lSize);
	
   // compute the size of each record stored in the binary file
   int recordsize=sizeof(int)+20+sizeof(float);
   printf("Size of Rec %d \n",recordsize);
	
   // compute the number of records found
   printf("Number of Records in File %d \n",(int)lSize/recordsize);

   // seek to the point of interest or go DIRECTLY
   // without reading all records up to that location..
   fseek(fpa,recordsize*(locationOfSoughtRec-1),SEEK_SET);

   // extract the pieces of information using high-level I/O fread()
   fread(&myid, sizeof(int), 1, fpa);
   fread(buffer, 20, 1, fpa);
   fread(&strsize, sizeof(float), 1, fpa);
   fprintf(stdout,">>> %d %s %f\n",myid, buffer, strsize);

   fclose(fpa);
}
