#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>

#define  SIZE 		1024
#define  PERM 		0644

int mycopyfile(char *name1, char *name2, int BUFFSIZE){
	int infile, outfile; /* file descriptors - integers */
	ssize_t nread;
	char buffer[BUFFSIZE];
	
	// open the first file for reading only..
	if ( (infile=open(name1,O_RDONLY)) == -1 )
		return(-1);

	// open the second file for writing with truncate option or 
	// create it if the file does not already exists 
	// the permissions of the new file are set to wr-wr-wr 
 	//
	if ( (outfile=open(name2, O_WRONLY|O_CREAT|O_TRUNC, PERM)) == -1){
		close(infile);
		return(-2);
		}

	// this is a key pattern.. 
	// you keep reading characters/bytes into a buffer 
 	// REGARDLESS of their content!!! 
 	// We may run into situations that the read might not 
	// read  BUFFSIZE characters - u got to check this 
	// at all times and act accordingly..
	while ( (nread=read(infile, buffer, BUFFSIZE) ) > 0 ){
		if ( write(outfile,buffer,nread) < nread ){
			// if something has gone bad in the writing...
			// close both file descriptors and return a flag -3
			close(infile); 
			close(outfile);
                        return(-3);
			}
		}
	// all writing has proceeded as expected
	// close files 
	close(infile); close(outfile);

	if (nread == -1 ) 
		// if no chars were read in the last fetch..
		return(-4);
		// else return 0
	else	return(0);
}

int main(int argc, char *argv[]){
	int 	status=0;
	char 	fileA[SIZE], fileB[SIZE];
	int 	MYBUFFsize=0;

	status=mycopyfile(argv[1],argv[2],atoi(argv[3]));
	exit(status);
}
